package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.MsgSendQueue;
import com.sa.ibiz.demo.demo.service.MsgSendQueueService;
import com.sa.ibiz.demo.demo.service.dto.MsgSendQueueSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/msgsendqueue")
public class MsgSendQueueResource
{
	@Autowired
	private MsgSendQueueService service;


	@PostMapping(value = "/create")
	public ResponseEntity<MsgSendQueue> create(@Validated @RequestBody MsgSendQueue data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("消息发送队列[create]操作发生错误","MsgSendQueue",data.getMsgsendqueueid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<MsgSendQueue> getDraft(@Validated @RequestBody MsgSendQueue data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("消息发送队列[getDraft]操作发生错误","MsgSendQueue","");
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<MsgSendQueue> remove(@Validated @RequestBody MsgSendQueue data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("消息发送队列[remove]操作发生错误","MsgSendQueue",data.getMsgsendqueueid().toString());
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<MsgSendQueue> get(@Validated @PathVariable String id){
		MsgSendQueue data=new MsgSendQueue();
		data.setMsgsendqueueid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("消息发送队列[get]操作发生错误","MsgSendQueue",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/update")
	public ResponseEntity<MsgSendQueue> update(@Validated @RequestBody MsgSendQueue data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("消息发送队列[update]操作发生错误","MsgSendQueue",data.getMsgsendqueueid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/checkKey")
	public ResponseEntity<MsgSendQueue> checkKey(@Validated @RequestBody MsgSendQueue data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("消息发送队列[checkKey]操作发生错误","MsgSendQueue",data.getMsgsendqueueid().toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<MsgSendQueue>> searchDefaultPage(@Validated @RequestBody MsgSendQueueSearchFilter filter){
		Page<MsgSendQueue> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<MsgSendQueue>> listDefault(@Validated @RequestBody MsgSendQueueSearchFilter filter){
		List<MsgSendQueue> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
